SystemOrganization addCategory: #'SqueakEnh-Keymap'!

!KeymapEditor methodsFor: '*keymap' stamp: 'sam 2/8/2004 01:04'!
sendActionToPasteUpMorph
	actionClass := PasteUpMorphMethodAction! !

!KeymapEditor methodsFor: '*keymap' stamp: 'sam 2/8/2004 01:04'!
actionSentToPasteUpMorph
	^actionClass == PasteUpMorphMethodAction! !

!KeymapEditor methodsFor: '*keymap' stamp: 'cds 12/25/2003 15:07'!
buildActionEditor
	| tm border row |
	tm _ TextMorph new.
	tm contentsWrapped: '';
		 extent: 200 @ 30.
	(border _ AlignmentMorph newRow) borderWidth: 1;
		 borderColor: Color black;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 addMorphBack: tm.
	row _ AlignmentMorph newRow.
	row cellInset: 8 @ 1;
		 color: Color transparent;
		 addMorphBack: self buildActionTypeSelector;
		 addMorphBack: border.
	actionField _ tm.
	row cellPositioning: #leftCenter.
	^ row! !

!KeymapEditor methodsFor: '*keymap' stamp: 'sam 2/8/2004 01:04'!
buildActionTypeSelector
	| column row radioButton stringMorph |
	column := AlignmentMorph newColumn beTransparent.
	column
		borderWidth: 1;
		borderColor: Color black;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap.
	#(#(#sendActionToEditor 'ParagraphEditor' 'Send the action message to the ParagraphEditor' #actionSentToEditor) #(#sendActionToMorph 'TextMorph' 'Send the action message to the TextMorph' #actionSentToMorph) #(#sendActionToPasteUpMorph 'World' 'Send the action message to the World' #actionSentToPasteUpMorph) #(#playKeystrokes 'Play keystrokes' 'Play the keystrokes supplied with the action' #actionIsPlayKeystrokes) #(#sendActionToClassMethod 'Class Method' 'Invoke the specified class method' #actionSentToClassMethod)) 
		do: 
			[:quad | 
			row := AlignmentMorph newRow beTransparent.
			row addMorph: (radioButton := UpdatingThreePhaseButtonMorph radioButton).
			radioButton
				target: self;
				setBalloonText: quad third;
				actionSelector: quad first;
				getSelector: quad fourth.
			row addTransparentSpacerOfSize: 4 @ 0.
			row 
				addMorphBack: (stringMorph := StringMorph contents: quad second asString).
			stringMorph setBalloonText: quad third.
			column addMorphBack: row].
	^column! !

!KeymapManager methodsFor: '*keymap' stamp: 'Samir Saidani 2/8/2004 00:51'!
installKeymap
	(self confirm: 'Install new keymap for new Morphs?')
		ifFalse: [^ self].
	Preferences keymap: self keymap.
	(self confirm: 'Install in existing Morphs?')
		ifTrue: [self installKeymapInExistingMorphs]! !

!KeymapManager methodsFor: '*keymap' stamp: 'Samir Saidani 2/8/2004 00:47'!
installKeymapInExistingMorphs
	TextMorph
		allSubInstancesDo: [:each | each keyMapper: nil].
			PasteUpMorph
		allSubInstancesDo: [:each | each keyMapper: nil]! !

!PasteUpMorph methodsFor: '*keymap' stamp: 'Samir Saidani 2/7/2004 14:20'!
keyMapperFinishedCommand: km 
	"Called by keymapper when a mult-key command sequence has been  
	executed. If any visual feedback was given to the user during the  
	command entry, it can be restored now"
	"self editor closeTypeIn"! !

!PasteUpMorph methodsFor: '*keymap' stamp: 'Samir Saidani 2/7/2004 14:19'!
handleInteraction: interActionBlock fromEvent: evt 
	"Overridden to pass along a model to the editor for, eg, link resolution, 
	doits, etc"
	"self editor model: editView model."
	"For evaluateSelection, etc"! !

!PasteUpMorph methodsFor: '*keymap' stamp: 'Samir Saidani 2/7/2004 01:45'!
keyMapper
	keyMapper
		ifNil: [keyMapper := KeyMapper on: self keyMapSpec: Preferences keymap].
	^ keyMapper! !

!PasteUpMorph methodsFor: '*keymap' stamp: 'Samir Saidani 2/8/2004 00:43'!
keyStroke: anEvent 
	"A keystroke has been made. Service event handlers and, if it's a  
	keystroke presented to the world, dispatch it to #unfocusedKeystroke:"
	super keyStroke: anEvent.
	"Give event handlers a chance"
	anEvent keyCharacter == Character tab
		ifTrue: [(self hasProperty: #tabAmongFields)
				ifTrue: [^ self tabHitWithEvent: anEvent]].
	self isWorldMorph
		ifTrue: [self keystrokeInWorld: anEvent].
	"hook for keymapper"
	
	[(self keyMapper match: anEvent)
		ifTrue: [^ self]]
		on: Error
		do: [:ex | ex signal]! !

!PasteUpMorph methodsFor: '*keymap' stamp: 'Samir Saidani 2/7/2004 01:45'!
keyMapperCommandInProcess: km 
	"Called by keymapper when a mult-key command sequence is being 
	typed by the user. KeyMapper target's can give some visual feedback 
	that a command is being entered, if desired."
	self editor closeTypeIn! !

!PasteUpMorph methodsFor: '*keymap' stamp: 'Samir Saidani 2/7/2004 01:45'!
keyMapperNoMatch: keys 
	"Called by keymapper when user enters a command that has no match"
	Smalltalk beep.
	self editor closeTypeIn! !

!PasteUpMorph methodsFor: '*keymap' stamp: 'Samir Saidani 2/7/2004 01:44'!
keyMapper: km 
	^ keyMapper := km! !

!PasteUpMorph methodsFor: '*keymap' stamp: 'Samir Saidani 2/7/2004 01:45'!
playKMKeystrokes: kmKeyString 
	"kmKeyString represents a sequence of keystrokes (in Keymapper 
	syntax, see class comment for KeyMapper). 'Play' those keystrokes as if 
	they were typed by the user"
	| evts |
	evts := KMFakeKeyEvent fromString: kmKeyString.
	self editor
		terminateAndInitializeAround: [evts
				do: [:evt | self keyStroke: evt]]! !

Object subclass: #PasteUpMorphMethodAction
	instanceVariableNames: 'commandClass selector actionString '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEnh-Keymap'!

!PasteUpMorphMethodAction methodsFor: 'printing' stamp: 'sam 2/8/2004 02:00'!
actionString: aString
actionString_ aString! !

!PasteUpMorphMethodAction methodsFor: 'printing' stamp: 'Samir Saidani 2/8/2004 00:16'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self actionString.
	aStream nextPut: $)! !

!PasteUpMorphMethodAction methodsFor: 'executing' stamp: 'sam 2/8/2004 02:05'!
executeForTarget: target events: evts 
Compiler evaluate: actionString! !

!PasteUpMorphMethodAction class methodsFor: 'instance creation' stamp: 'sam 2/8/2004 02:09'!
fromString: aString 
	^ self new actionString: aString;
		 yourself! !

!PasteUpMorphMethodAction methodsFor: 'printing' stamp: 'sam 2/8/2004 02:00'!
actionString
	^ actionString! !

PackageInfo subclass: #KeymapInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEnh-Keymap'!

!KeymapInfo methodsFor: 'as yet unclassified' stamp: 'sam 2/8/2004 00:58'!
methodCategoryPrefix
	^ '*keymap'! !
